#!/bin/sh
# \
exec wish "$0" "$@"
package require BLT

option add *Font {Helvetica -12 bold} 
option add *Entry.Background snow 
option add *Entry.Font {Courier -18}
option add *Label.Font {Helvetica -14 bold}

source query.tcl
source database.tcl
source dialog.tcl
source imagens.tcl

#### exemplo

frame .top
pack [frame .top.fr -relief sunken -bd 2] -padx 5 -pady 5 
pack [button .top.fr.quit -text quit -command exit] \
		-side left -padx 10 -pady 5 
pack .top  -side bottom -fill x

frame .left
::blt::hierbox .left.hb -selectmode single -hideroot 1 \
	-height 150 -width 200 -yscrollcommand {.left.sb set} 
scrollbar .left.sb -width 10 -command {.left.hb yview} 
pack .left.sb -side right -fill y 
pack .left.hb -side left -fill both 

#-opencommand {puts "open: %n"}
frame .right -width 300 -relief sunken -bd 2
#pack propagate .right 0
canvas .right.cv -yscrollcommand {.right.vs set} \
	-xscrollcommand {.right.hs set}
scrollbar .right.hs -orient horizontal -width 10 \
	-command {.right.cv xview} 
scrollbar .right.vs -orient vertical -width 10 \
	-command {.right.cv yview}
pack .right.hs -side bottom -fill x
pack .right.vs -side right -fill y
pack .right.cv -side left -fill both -expand 1
pack .left -side left -fill both -padx 10 -pady 10
pack .right -side left -expand 1 -fill both -padx 10 -pady 10

foreach i [DB_databases] {
	.left.hb insert end $i -icons img_db
	foreach r [DB_classes $i] {
		.left.hb insert -at $i end $r -icons img_table
	}
}

menu .left.hb.m -tearoff 0
.left.hb.m add command -label "new database"
.left.hb.m add command -label "new table"
.left.hb.m add command -label "edit table" -command db_edit_table
.left.hb.m add command -label "delete table"
.left.hb.m add command -label "delete database"

bind .left.hb <3> {
	tk_popup .left.hb.m [winfo pointerx .] [winfo pointery .] 
}

bind .left.hb <1> {
	set ls [join [.left.hb get -full [.left.hb curselection]]]
	set db [lindex $ls 1]
	set tbl [lindex $ls 2]
	if {[winfo exists .right.cv.f]} {
		destroy .right.cv.f
	}
	if {$tbl != ""} {
		global $tbl
		set f [frame .right.cv.f -bd 0 -bg gray90]
		.right.cv create window 0 0 -anchor nw -window $f
		if {[info procs $tbl]=={}} {
			query_opendb $db
			query $tbl -multiple 1
			$tbl select
		}
		set j 0
		foreach attr [$tbl attributes] {
			grid [button $f.b$j -text [lindex $attr 0] -anchor w \
				-width [lindex $attr 1]] -row 0 -column $j -sticky nsew
			incr j
		}
		for {set i 0} {$i<50} {incr i} {
			set j 0	
			foreach attr [$tbl attributes] {
				set at [lindex $attr 0]
				set len [lindex $attr 1]
				set e [entry $f.$i,$j -width $len -relief flat -bg white \
					-textvariable ${tbl}($i,$at)]
				grid $e -row [expr $i+1] -column $j
				incr j
			}
		}
		tkwait visibility $f.0,0
		set totwid 300
#		set totwid 0
#		for {set k 0} {$k < $j} {incr k} {
#			if {$totwid < 400} {
#				incr totwid [winfo width $f.0,$k]
#			}
#		}
		set width [winfo width $f]
		set single [winfo height $f.0,0]
		set height [winfo height $f]
		#set vheight [expr 8 * $single]
		.right.cv config -scrollregion "0 0 $width $height" \
			-yscrollincrement $single -width $totwid 
			#-height $vheight
	}
}

proc db_edit_table { } {
	set ls [db_select_table]
	set db [lindex $ls 1]
	set tbl [lindex $ls 2]
	global edittbl
	set f .edittbl
	set edittbl(type) bpchar
	set edittbl(ok) 0

	DB_attrprop $db $tbl edittbl 
	db_edittbl_adjust 0

	if {[Dialog_Create $f "Edit Table <$tbl>" -borderwidth 10]} {
		label $f.tit -text "Table $tbl" -font {Helvetica -24 bold}
		label $f.lb1 -text "field name"
		entry $f.e -textvariable edittbl(field) -width 40
		label $f.lb2 -text "field width"
		entry $f.width -textvariable edittbl(fieldwidth) -width 3
		set r [frame $f.r -bd 2 -relief sunken]
		radiobutton $r.rb1 -text smallinteger \
			-variable edittbl(type) -value int2 
		radiobutton $r.rb2 -text integer  \
			-variable edittbl(type) -value int4 
		radiobutton $r.rb3 -text float  \
			-variable edittbl(type) -value float
		radiobutton $r.rb4 -text money  \
			-variable edittbl(type) -value money
		radiobutton $r.rb5 -text date \
			-variable edittbl(type) -value date 
		radiobutton $r.rb6 -text char  \
			-variable edittbl(type) -value bpchar 
		radiobutton $r.rb7 -text varchar  \
			-variable edittbl(type) -value varchar 
		pack $r.rb1 $r.rb2 $r.rb3 $r.rb4 $r.rb5 $r.rb6 $r.rb7 -anchor nw
		label $f.lb3 -text "field#"
		label $f.lb4 -textvariable edittbl(i)
		grid $f.tit -row 0 -column 0 -columnspan 3
		grid $f.lb1 -row 1 -column 0 -sticky sw
		grid $f.e  -row 2 -column 0 -columnspan 3 -sticky nw
		grid $f.lb2 -row 3 -column 0 -sticky sw
		grid $f.width -row 4 -column 0 -sticky nw
		grid $f.lb3 -row 3 -column 1 -sticky e
		grid $f.lb4 -row 3 -column 2 -sticky w
		grid $f.r  -row 0 -column 3 -rowspan 7 -padx 10
		set b [frame $f.buttons]
		grid $b -row 5 -column 0 -columnspan 2 -rowspan 3 
		button $b.next -text "next >>" -command { db_edittbl_adjust +1 }
		button $b.ok -text finish -command {set edittbl(ok) 1}
		button $b.cancel -text cancel -command {set edittbl(ok) 0}
		button $b.prev -text "<< prev" -command { db_edittbl_adjust -1 }
		pack $b.ok $b.cancel $b.prev $b.next \
			-side left -expand 1 -pady 5
	}
	Dialog_Wait $f edittbl(ok) $f.e
	Dialog_Dismiss $f
}

proc db_edittbl_adjust { adj } {
	global edittbl
	switch -- $adj {
	+1  { 
			set i $edittbl(i)
			set edittbl($i,attname) $edittbl(field) 
			set edittbl($i,attlen) $edittbl(fieldwidth)
			set edittbl($i,atttyp) $edittbl(type)
			if {[string compare new_field $edittbl($i,attname)]!=0} {
				incr edittbl(i)
				set i $edittbl(i)
				if {![info exists edittbl($i,attname)]} {
					set edittbl($i,attname) new_field 
					set edittbl($i,attlen) 20
					set edittbl($i,atttyp) bpchar
				}
			}
		}
	-1  { 
			set i $edittbl(i)
			set edittbl($i,attname) $edittbl(field) 
			set edittbl($i,attlen) $edittbl(fieldwidth)
			set edittbl($i,atttyp) $edittbl(type)
			if  {$edittbl(i) > 0} { 
				incr edittbl(i) -1 
			}
		}
	clear {
			foreach n [array names edittbl(*,*)] {
				unset edittbl($n)
			}
			set edittbl(0,attname) new_field
			set edittbl(0,attlen) 20
			set edittbl(0,atttyp) bpchar
			set edittbl(i) 0
		}
	default { set edittbl(i) $adj }
	}
	set i $edittbl(i)
	set edittbl(field) $edittbl($i,attname)
	set edittbl(fieldwidth) $edittbl($i,attlen)
	set edittbl(type) $edittbl($i,atttyp)
}

proc db_select_table { } {
	set ls [join [.left.hb get -full [.left.hb curselection]]]
	if {[llength $ls] <= 2} {
		error "no table selected.\nPlease select a table first"
	}
	#puts "editing table [lindex $ls 2]"
	return $ls
}

