#!/bin/sh
# \
exec wish "$0" "$@"

source query.tcl

#### exemplo
query_opendb loja
query produto -idattr prodid -multiple 1 -order pnome
query fornecedor -idattr fornid
produto add fornecedor

#### GUI para o exemplo
	set nlines 5
	frame .top
	message .top.msg -text "Exemplo com uma tabela\n(opo -multiple 1)" \
		-width 15c -font {Helvetica 26 bold}
	pack .top.msg
	pack .top -fill x -expand 1
	frame .c
	canvas .c.cv \
		-yscrollcommand [list .c.yscroll set] \
		-xscrollcommand [list .c.xscroll set]
	scrollbar .c.yscroll -orient vertical -width 10 \
		-takefocus 0 -command [list .c.cv yview]
	scrollbar .c.xscroll -orient horizontal -width 10 \
		-takefocus 0 -command [list .c.cv xview]
	pack .c.xscroll -side bottom -fill x
	pack .c.yscroll -side right -fill y
	pack .c.cv -side left 
	pack .c  
	frame .bts
	button .bts.select -text select -command {produto select}
	button .bts.clear -text clear -command {produto clear}
	button .bts.update -text update -command {
		set v [[focus] cget -textvariable] 
		regexp {.*\(([0-9]*).*} $v match idx
		produto set $idx
		produto update
	}
	button .bts.quit -text quit -command exit
	pack .bts.select .bts.clear .bts.update .bts.quit -side left
	pack .bts -side bottom
	
	
# cria um frame para conter tudo (no interior do canvas)
	set f [frame .c.cv.f -bd 0 -bg gray90]
	.c.cv create window 0 0 -anchor nw -window $f

# cria entidades do formulario
#		foreach attr [concat [produto attributes] [fornecedor attributes]] 
	for {set i 0} {$i < 20} {incr i} {
		set j 0
		foreach attr {{prodid 6} {pnome 35} {fnome 20}} {
			set at [lindex $attr 0]
			set len [lindex $attr 1]
			set e [entry $f.$i,$j -font {courier -20 bold} \
				-highlightthickness 2 -highlightbackground black \
				-width $len -relief flat -bg white \
				-textvariable produto($i,$at)]
			grid $e -row $i -column $j
			incr j
		}
	}
# espera pela janela ficar visvel para obter suas medidas
	tkwait visibility $f.0,0
	set width [winfo  width $f]
	set cwidth 500
	set single [winfo height $f.0,0]
	set height [winfo height $f]

# restringe canvas para ele no rolar alm dos limites
	.c.cv config -scrollregion "0 0 $width $height"
	.c.cv config -yscrollincrement $single
	if {$height > $nlines * $single} {
		set height [expr $nlines * $single]
	}
	.c.cv config -width $cwidth -height $height

# ==========================================================
